---
{{ template "common.rbac.ServiceAccount" (list .) }}

---
{{ template "common.rbac.ClusterRole" (list . "source-controller.rbac.ClusterRole") }}

{{- define "source-controller.rbac.ClusterRole" }}
rules:
  - apiGroups:
      - ""
    resources:
      - events
    verbs:
      - create
      - patch
{{- end }}

---
{{ template "common.rbac.ClusterRoleBinding" (list . "source-controller.rbac.ClusterRoleBinding") }}

{{- define "source-controller.rbac.ClusterRoleBinding" }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: {{ template "common.fullname" . }}
subjects:
  - kind: ServiceAccount
    name: {{ template "common.fullname" . }}
    namespace: {{ .Release.Namespace }}
{{- end }}

---
{{ template "common.rbac.Role" (list . "source-controller.rbac.Role") }}

{{- define "source-controller.rbac.Role" }}
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: {{ template "common.fullname" . }}
  labels:
    app.kubernetes.io/name: {{ template "common.name" . }}
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/managed-by: {{ .Release.Service }}
    source.sh/chart: {{ template "common.chart" . }}
rules:
  - apiGroups:
      - ""
    resources:
      - configmaps
      - configmaps/status
    verbs:
      - get
      - list
      - watch
      - create
      - update
      - patch
      - delete
  - apiGroups:
      - coordination.k8s.io
    resources:
      - leases
    verbs:
      - create
      - delete
      - get
      - list
      - patch
      - update
      - watch
  - apiGroups:
      - ""
    resources:
      - secrets
    verbs:
      - get
      - list
      - watch
  - apiGroups:
      - source.toolkit.fluxcd.io
    resources:
      - "*"
    verbs:
      - get
      - list
      - patch
      - update
      - watch
{{- end }}

---
{{ template "common.rbac.RoleBinding" (list . "source-controller.rbac.RoleBinding") }}

{{- define "source-controller.rbac.RoleBinding" }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: {{ template "common.fullname" . }}
subjects:
  - kind: ServiceAccount
    name: {{ template "common.fullname" . }}
    namespace: {{ .Release.Namespace }}
{{- end }}
